概述
题面链接
https://ac.nowcoder.com/acm/contest/23106/J
题面
思路
思路一
对于这个问题,我们很显然能想到二路归并,其实也就是模拟,不过我们从两边,安静的小朋友和闹腾的小朋友中选取总共m个小朋友,我们可以用两个优先队列来维护,尽量选择安静小朋友的,那么我们至多选择 ⌊ m 2 ⌋ left lfloor frac{m}{2} right rfloor ⌊2m⌋个闹腾的小朋友,所以直接模拟归并就好啦,复杂度 n l o g n nlog_n nlogn
思路二
我们对安静的小朋友和闹腾的小朋友先进行一个排序,排完序后对两边的小朋友求一个前缀和,求完前缀和,我们直接枚举小朋友的个数即可,复杂度 O ( n l o g n ) O(nlog_n) O(nlogn)
代码
优先队列代码
#include<bits/stdc++.h>
using namespace std;
//----------------�Զ��岿��----------------
#define ll long long
#define int long long
#define mod 1000000007
#define endl "n"
#define PII pair<int,int>
int dx[4]={0,-1,0,1},dy[4]={-1,0,1,0};
ll ksm(ll a,ll b) {
ll ans = 1;
for(;b;b>>=1LL) {
if(b & 1) ans = ans * a % mod;
a = a * a % mod;
}
return ans;
}
ll lowbit(ll x){return -x & x;}
const int N = 2e6+10;
//----------------�Զ��岿��----------------
int n,m,q,a[N],A,B;
void slove(){
cin>>A>>B>>n;
priority_queue<int> quea,queb;
int k;
for(int i = 1;i <= A; ++i) {
cin>>k; quea.push(k);
}
for(int i = 1;i <= B; ++i) {
cin>>k; queb.push(k);
}
int cnta,cntb;
cnta = cntb = 0;
int ans = 0;
int tt = n;
priority_queue<int,vector<int>,greater<int> > remainb;
while(quea.size() && queb.size() && tt){
if(quea.top() >= queb.top()){
cnta++;
ans += quea.top();
quea.pop();
}else{
cntb++;
ans += queb.top();
remainb.push(queb.top());
queb.pop();
}
tt--;
}
if(tt) {
while(quea.size() && tt) {
cnta++;
ans += quea.top();
quea.pop();
tt--;
}
while(queb.size() && tt){
cntb++;
ans += queb.top();
remainb.push(queb.top());
queb.pop();
tt--;
}
}
while(quea.size()&& remainb.size() && cntb > (n>>1)){
ans -= remainb.top();
ans += quea.top();
quea.pop();
remainb.pop();
cntb--;
cnta++;
}
if(cntb > (n>>1) || (cnta+cntb) != n) cout<<-1<<endl;
else cout<<ans<<endl;
}
signed main()
{
std::ios::sync_with_stdio(false);
std::cin.tie(nullptr);
std::cout.tie(nullptr);
int t;
cin>>t;
while(t--) {
slove();
}
return 0;
}
最后
以上就是敏感菠萝为你收集整理的小朋友做游戏(优先队列 or 前缀和 + 枚举)题面链接题面思路代码的全部内容,希望文章能够帮你解决小朋友做游戏(优先队列 or 前缀和 + 枚举)题面链接题面思路代码所遇到的程序开发问题。
如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。
发表评论 取消回复